Gentoo Archives: gentoo-commits

From: Nick Sarnie <sarnex@g.o>
To: gentoo-commits@l.g.o
Subject: [gentoo-commits] repo/proj/wine:master commit in: app-emulation/wine-vanilla/
Date: Sat, 27 Feb 2021 20:10:51
Message-Id: 1614456634.49e85d4ceb093c50436f6d3eddc9fc3fb941eb85.sarnex@gentoo
1 commit: 49e85d4ceb093c50436f6d3eddc9fc3fb941eb85
2 Author: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
3 AuthorDate: Sat Feb 27 20:06:56 2021 +0000
4 Commit: Nick Sarnie <sarnex <AT> gentoo <DOT> org>
5 CommitDate: Sat Feb 27 20:10:34 2021 +0000
6 URL: https://gitweb.gentoo.org/repo/proj/wine.git/commit/?id=49e85d4c
7
8 app-emulation/wine-vanilla: Bump to 6.3
9
10 Package-Manager: Portage-3.0.16, Repoman-3.0.2
11 Signed-off-by: Nick Sarnie <sarnex <AT> gentoo.org>
12
13 app-emulation/wine-vanilla/Manifest | 1 +
14 app-emulation/wine-vanilla/wine-vanilla-6.3.ebuild | 579 +++++++++++++++++++++
15 2 files changed, 580 insertions(+)
16
17 diff --git a/app-emulation/wine-vanilla/Manifest b/app-emulation/wine-vanilla/Manifest
18 index 89ba4a1..fcbb9a6 100644
19 --- a/app-emulation/wine-vanilla/Manifest
20 +++ b/app-emulation/wine-vanilla/Manifest
21 @@ -57,3 +57,4 @@ DIST wine-5.9.tar.xz 23802356 BLAKE2B 1879c164c647a5b849056e4149a809c390814ae832
22 DIST wine-6.0.tar.xz 24192280 BLAKE2B baf0eee582190ede8d210390b51d330c1879cb442100bc2e957052898fbd84bcc047a885065f9bf96ac4f072f92eee44f0e1c3baddc68937286e7cc6f976bd4e SHA512 c0732fbab1da8737d595a876b28ce87eef1440c317746e798642b59b44b34e890de562e0c0cc674e97096f39db82f8e9c3b1cc1ba9edc246b7266a0f7cb00057
23 DIST wine-6.1.tar.xz 24227160 BLAKE2B 968405fb8a4060732a6070687e28aecc9169692bf18e058d358e859a2626281b5adb67b94d849628ecbfa87ad772a367f62fd3c5f45aecdf7d0a7e7aa8167c33 SHA512 49ee77c41e2fb1c4f22417117b26f8a467ec6c99583fca66f147003f776fcaf5ca42227153c7ca3325dfe70141ae9bfb88e3eb6e4cf25dd31a5ba5115d2685d0
24 DIST wine-6.2.tar.xz 24270924 BLAKE2B b83e7ff097d8f48cc46588a672515e8c1eafeafd592d4ced6a8347eaa33c31f9c5a2603958a10ce02463993c8ca5db77b227d0fbce452c1e3a637e5ea42cf635 SHA512 d28870ba58fc4ed9dc083f843d7f4ee8921722bb33e0b84c89f281fc27e5f827c0998ad629eb21c92f860dade77194d3c8a0f5b4c6ae3407fe7acef245cfa9a4
25 +DIST wine-6.3.tar.xz 24301496 BLAKE2B d36e46e369abc619d351dd3209c0c86c5e5924509fe98a9e158fd10b9ca57650b9bc20e64dc801ec1b09315ed77fd81b549ebce7f383a3f772717a2031878588 SHA512 20108ea5036d612e8dd61fe9254d67cad02d757ede87174ed27774e4e3537e0d1f4d67156fd430f1d01d5c68b899cb0c7b4be298d897a1ce823913efef822242
26
27 diff --git a/app-emulation/wine-vanilla/wine-vanilla-6.3.ebuild b/app-emulation/wine-vanilla/wine-vanilla-6.3.ebuild
28 new file mode 100644
29 index 0000000..045e3bf
30 --- /dev/null
31 +++ b/app-emulation/wine-vanilla/wine-vanilla-6.3.ebuild
32 @@ -0,0 +1,579 @@
33 +# Copyright 1999-2021 Gentoo Authors
34 +# Distributed under the terms of the GNU General Public License v2
35 +
36 +EAPI=6
37 +
38 +PLOCALES="ar ast bg ca cs da de el en en_US eo es fa fi fr he hi hr hu it ja ko lt ml nb_NO nl or pa pl pt_BR pt_PT rm ro ru si sk sl sr_RS@cyrillic sr_RS@latin sv ta te th tr uk wa zh_CN zh_TW"
39 +PLOCALE_BACKUP="en"
40 +
41 +inherit autotools eapi7-ver estack eutils flag-o-matic gnome2-utils l10n multilib multilib-minimal pax-utils toolchain-funcs virtualx xdg-utils
42 +
43 +MY_PN="${PN%%-*}"
44 +MY_P="${MY_PN}-${PV}"
45 +
46 +if [[ ${PV} == "9999" ]] ; then
47 + EGIT_REPO_URI="https://source.winehq.org/git/wine.git"
48 + EGIT_BRANCH="master"
49 + inherit git-r3
50 + SRC_URI=""
51 + #KEYWORDS=""
52 +else
53 + MAJOR_V=$(ver_cut 1)
54 + SRC_URI="https://dl.winehq.org/wine/source/${MAJOR_V}.x/${MY_P}.tar.xz"
55 + KEYWORDS="-* ~amd64 ~x86"
56 +fi
57 +S="${WORKDIR}/${MY_P}"
58 +
59 +GWP_V="20200523"
60 +PATCHDIR="${WORKDIR}/gentoo-wine-patches"
61 +
62 +DESCRIPTION="Free implementation of Windows(tm) on Unix, without external patchsets"
63 +HOMEPAGE="https://www.winehq.org/"
64 +SRC_URI="${SRC_URI}
65 + https://dev.gentoo.org/~sarnex/distfiles/wine/gentoo-wine-patches-${GWP_V}.tar.xz
66 +"
67 +
68 +LICENSE="LGPL-2.1"
69 +SLOT="${PV}"
70 +IUSE="+abi_x86_32 +abi_x86_64 +alsa capi cups custom-cflags dos elibc_glibc +faudio +fontconfig +gecko gphoto2 gsm gssapi gstreamer +jpeg kerberos kernel_FreeBSD +lcms ldap mingw +mono mp3 netapi nls odbc openal opencl +opengl osmesa oss +perl pcap +png prelink pulseaudio +realtime +run-exes samba scanner sdl selinux +ssl test +threads +truetype udev +udisks +unwind usb v4l vkd3d vulkan +X +xcomposite xinerama +xml"
71 +REQUIRED_USE="|| ( abi_x86_32 abi_x86_64 )
72 + X? ( truetype )
73 + elibc_glibc? ( threads )
74 + osmesa? ( opengl )
75 + test? ( abi_x86_32 )
76 + vkd3d? ( vulkan )" # osmesa-opengl #286560 # X-truetype #551124
77 +
78 +# FIXME: the test suite is unsuitable for us; many tests require net access
79 +# or fail due to Xvfb's opengl limitations.
80 +RESTRICT="test"
81 +
82 +COMMON_DEPEND="
83 + X? (
84 + x11-libs/libXcursor[${MULTILIB_USEDEP}]
85 + x11-libs/libXext[${MULTILIB_USEDEP}]
86 + x11-libs/libXfixes[${MULTILIB_USEDEP}]
87 + x11-libs/libXrandr[${MULTILIB_USEDEP}]
88 + x11-libs/libXi[${MULTILIB_USEDEP}]
89 + x11-libs/libXxf86vm[${MULTILIB_USEDEP}]
90 + )
91 + alsa? ( media-libs/alsa-lib[${MULTILIB_USEDEP}] )
92 + capi? ( net-libs/libcapi[${MULTILIB_USEDEP}] )
93 + cups? ( net-print/cups:=[${MULTILIB_USEDEP}] )
94 + faudio? ( app-emulation/faudio:=[${MULTILIB_USEDEP}] )
95 + fontconfig? ( media-libs/fontconfig:=[${MULTILIB_USEDEP}] )
96 + gphoto2? ( media-libs/libgphoto2:=[${MULTILIB_USEDEP}] )
97 + gsm? ( media-sound/gsm:=[${MULTILIB_USEDEP}] )
98 + gssapi? ( virtual/krb5[${MULTILIB_USEDEP}] )
99 + gstreamer? (
100 + media-libs/gstreamer:1.0[${MULTILIB_USEDEP}]
101 + media-plugins/gst-plugins-meta:1.0[${MULTILIB_USEDEP}]
102 + )
103 + jpeg? ( virtual/jpeg:0=[${MULTILIB_USEDEP}] )
104 + kerberos? ( virtual/krb5[${MULTILIB_USEDEP}] )
105 + lcms? ( media-libs/lcms:2=[${MULTILIB_USEDEP}] )
106 + ldap? ( net-nds/openldap:=[${MULTILIB_USEDEP}] )
107 + mp3? ( >=media-sound/mpg123-1.5.0[${MULTILIB_USEDEP}] )
108 + netapi? ( net-fs/samba[netapi(+),${MULTILIB_USEDEP}] )
109 + nls? ( sys-devel/gettext[${MULTILIB_USEDEP}] )
110 + odbc? ( dev-db/unixODBC:=[${MULTILIB_USEDEP}] )
111 + openal? ( media-libs/openal:=[${MULTILIB_USEDEP}] )
112 + opencl? ( virtual/opencl[${MULTILIB_USEDEP}] )
113 + opengl? (
114 + virtual/glu[${MULTILIB_USEDEP}]
115 + virtual/opengl[${MULTILIB_USEDEP}]
116 + )
117 + osmesa? ( >=media-libs/mesa-13[osmesa,${MULTILIB_USEDEP}] )
118 + pcap? ( net-libs/libpcap[${MULTILIB_USEDEP}] )
119 + png? ( media-libs/libpng:0=[${MULTILIB_USEDEP}] )
120 + pulseaudio? ( media-sound/pulseaudio[${MULTILIB_USEDEP}] )
121 + scanner? ( media-gfx/sane-backends:=[${MULTILIB_USEDEP}] )
122 + sdl? ( media-libs/libsdl2:=[haptic,joystick,${MULTILIB_USEDEP}] )
123 + ssl? ( net-libs/gnutls:=[${MULTILIB_USEDEP}] )
124 + truetype? ( >=media-libs/freetype-2.0.0[${MULTILIB_USEDEP}] )
125 + udev? ( virtual/libudev:=[${MULTILIB_USEDEP}] )
126 + udisks? ( sys-apps/dbus[${MULTILIB_USEDEP}] )
127 + unwind? ( sys-libs/libunwind[${MULTILIB_USEDEP}] )
128 + usb? ( virtual/libusb:1[${MULTILIB_USEDEP}] )
129 + v4l? ( media-libs/libv4l[${MULTILIB_USEDEP}] )
130 + vkd3d? ( >=app-emulation/vkd3d-1.2[${MULTILIB_USEDEP}] )
131 + vulkan? ( media-libs/vulkan-loader[${MULTILIB_USEDEP}] )
132 + xcomposite? ( x11-libs/libXcomposite[${MULTILIB_USEDEP}] )
133 + xinerama? ( x11-libs/libXinerama[${MULTILIB_USEDEP}] )
134 + xml? (
135 + dev-libs/libxml2[${MULTILIB_USEDEP}]
136 + dev-libs/libxslt[${MULTILIB_USEDEP}]
137 + )"
138 +
139 +RDEPEND="${COMMON_DEPEND}
140 + app-emulation/wine-desktop-common
141 + >app-eselect/eselect-wine-0.3
142 + !app-emulation/wine:0
143 + dos? ( >=games-emulation/dosbox-0.74_p20160629 )
144 + gecko? ( app-emulation/wine-gecko:2.47.2[abi_x86_32?,abi_x86_64?] )
145 + mono? ( app-emulation/wine-mono:6.0.0 )
146 + perl? (
147 + dev-lang/perl
148 + dev-perl/XML-Simple
149 + )
150 + pulseaudio? (
151 + realtime? ( sys-auth/rtkit )
152 + )
153 + samba? ( >=net-fs/samba-3.0.25[winbind] )
154 + selinux? ( sec-policy/selinux-wine )
155 + udisks? ( sys-fs/udisks:2 )"
156 +
157 +# tools/make_requests requires perl
158 +DEPEND="${COMMON_DEPEND}
159 + sys-devel/flex
160 + >=sys-kernel/linux-headers-2.6
161 + virtual/pkgconfig
162 + virtual/yacc
163 + X? ( x11-base/xorg-proto )
164 + prelink? ( sys-devel/prelink )
165 + xinerama? ( x11-base/xorg-proto )"
166 +
167 +# These use a non-standard "Wine" category, which is provided by
168 +# /etc/xdg/applications-merged/wine.menu
169 +QA_DESKTOP_FILE="usr/share/applications/wine-browsedrive.desktop
170 +usr/share/applications/wine-notepad.desktop
171 +usr/share/applications/wine-uninstaller.desktop
172 +usr/share/applications/wine-winecfg.desktop"
173 +
174 +PATCHES=(
175 + "${PATCHDIR}/patches/${MY_PN}-5.0-winegcc.patch" #260726
176 + "${PATCHDIR}/patches/${MY_PN}-4.7-multilib-portage.patch" #395615
177 + "${PATCHDIR}/patches/${MY_PN}-2.0-multislot-apploader.patch" #310611
178 + "${PATCHDIR}/patches/${MY_PN}-5.9-Revert-makedep-Install-also-generated-typelib-for-in.patch"
179 +)
180 +PATCHES_BIN=()
181 +
182 +# https://bugs.gentoo.org/show_bug.cgi?id=635222
183 +if [[ ${#PATCHES_BIN[@]} -ge 1 ]] || [[ ${PV} == 9999 ]]; then
184 + DEPEND+=" dev-util/patchbin"
185 +fi
186 +
187 +wine_compiler_check() {
188 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
189 +
190 + # GCC-specific bugs
191 + if tc-is-gcc; then
192 + # bug #549768
193 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) -le 2 ]]; then
194 + ebegin "Checking for gcc-5 ms_abi compiler bug"
195 + $(tc-getCC) -O2 "${PATCHDIR}/files/pr66838.c" -o "${T}"/pr66838 || die
196 + # Run in subshell to prevent "Aborted" message
197 + ( "${T}"/pr66838 || false ) >/dev/null 2>&1
198 + if ! eend $?; then
199 + eerror "64-bit wine cannot be built with gcc-5.1 or initial patchset of 5.2.0"
200 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.2.x ebuild,"
201 + eerror "or use gcc-config to select a different compiler version."
202 + eerror "See https://bugs.gentoo.org/549768"
203 + eerror
204 + return 1
205 + fi
206 + fi
207 + # bug #574044
208 + if use abi_x86_64 && [[ $(gcc-major-version) = 5 && $(gcc-minor-version) = 3 ]]; then
209 + ebegin "Checking for gcc-5-3 stack realignment compiler bug"
210 + # Compile in subshell to prevent "Aborted" message
211 + ( $(tc-getCC) -O2 -mincoming-stack-boundary=3 "${PATCHDIR}/files/pr69140.c" -o "${T}"/pr69140 ) >/dev/null 2>&1
212 + if ! eend $?; then
213 + eerror "Wine cannot be built with this version of gcc-5.3"
214 + eerror "due to compiler bugs; please re-emerge the latest gcc-5.3.x ebuild,"
215 + eerror "or use gcc-config to select a different compiler version."
216 + eerror "See https://bugs.gentoo.org/574044"
217 + eerror
218 + return 1
219 + fi
220 + fi
221 + fi
222 +
223 + # Ensure compiler support
224 + if use abi_x86_64; then
225 + ebegin "Checking for 64-bit compiler with builtin_ms_va_list support"
226 + # Compile in subshell to prevent "Aborted" message
227 + ( $(tc-getCC) -O2 "${PATCHDIR}/files/builtin_ms_va_list.c" -o "${T}"/builtin_ms_va_list >/dev/null 2>&1)
228 + if ! eend $?; then
229 + eerror "This version of $(tc-getCC) does not support builtin_ms_va_list, can't enable 64-bit wine"
230 + eerror
231 + eerror "You need gcc-4.4+ or clang 3.8+ to build 64-bit wine"
232 + eerror
233 + return 1
234 + fi
235 + fi
236 +}
237 +
238 +wine_build_environment_check() {
239 + [[ ${MERGE_TYPE} = "binary" ]] && return 0
240 +
241 + if use abi_x86_64; then
242 + if tc-is-gcc && [[ $(gcc-major-version) -lt 4 || ( $(gcc-major-version) -eq 4 && $(gcc-minor-version) -lt 4 ) ]]; then
243 + eerror "You need gcc-4.4+ to compile 64-bit wine"
244 + die
245 + elif tc-is-clang && [[ $(clang-major-version) -lt 3 || ( $(clang-major-version) -eq 3 && $(clang-minor-version) -lt 8 ) ]]; then
246 + eerror "You need clang-3.8+ to compile 64-bit wine"
247 + die
248 + fi
249 + fi
250 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -le 3 ]]; then
251 + ewarn "GCC-5.0-5.3 suffered from compiler bugs and are no longer supported by"
252 + ewarn "Gentoo's Toolchain Team. If your ebuild fails the compiler checks in"
253 + ewarn "the configure phase, either update your compiler or switch to <5.0 || >=5.4"
254 + fi
255 + if tc-is-gcc && [[ $(gcc-major-version) -eq 5 && $(gcc-minor-version) -eq 4 ]]; then
256 + if has "-march=i686" ${CFLAGS} && ! has "-mtune=generic" ${CFLAGS}; then
257 + ewarn "Compilation can hang with CFLAGS=\"-march=i686\". You can temporarily work"
258 + ewarn "around this by adding \"-mtune=generic\" to your CFLAGS for wine."
259 + ewarn "See package.env in man 5 portage for more information on how to do this."
260 + ewarn "See https://bugs.gentoo.org/show_bug.cgi?id=613128 for more details"
261 + fi
262 + fi
263 +
264 + if use abi_x86_32 && use opencl && [[ "$(eselect opencl show 2> /dev/null)" == "intel" ]]; then
265 + eerror "You cannot build wine with USE=opencl because intel-ocl-sdk is 64-bit only."
266 + eerror "See https://bugs.gentoo.org/487864 for more details."
267 + eerror
268 + return 1
269 + fi
270 +}
271 +
272 +wine_env_vcs_vars() {
273 + local pn_live_var="${PN//[-+]/_}_LIVE_COMMIT"
274 + local pn_live_val="${pn_live_var}"
275 + eval pn_live_val='$'${pn_live_val}
276 + if [[ ! -z ${EGIT_COMMIT} ]]; then
277 + eerror "Commits must now be specified using the environmental variables"
278 + eerror "EGIT_OVERRIDE_COMMIT_WINE"
279 + eerror
280 + return 1
281 + fi
282 +}
283 +
284 +pkg_pretend() {
285 + wine_build_environment_check || die
286 +
287 + # Verify OSS support
288 + if use oss && ! use kernel_FreeBSD; then
289 + if ! has_version ">=media-sound/oss-4"; then
290 + eerror "You cannot build wine with USE=oss without having support from a"
291 + eerror "FreeBSD kernel or >=media-sound/oss-4 (only available through external repos)"
292 + eerror
293 + die
294 + fi
295 + fi
296 +
297 + if use mingw && use abi_x86_32 && ! has_version "cross-i686-w64-mingw32/gcc"; then
298 + eerror
299 + eerror "USE=\"mingw\" is currently experimental, and requires the"
300 + eerror "'cross-i686-w64-mingw32' compiler and its runtime for 32-bit builds."
301 + eerror
302 + eerror "These can be installed by using 'sys-devel/crossdev':"
303 + eerror
304 + eerror "crossdev --target i686-w64-mingw32"
305 + eerror
306 + eerror "For more information on setting up MinGW, see: https://wiki.gentoo.org/wiki/Mingw"
307 + eerror
308 + die "MinGW build was enabled, but no compiler to support it was found."
309 + fi
310 +
311 + if use mingw && use abi_x86_64 && ! has_version "cross-x86_64-w64-mingw32/gcc"; then
312 + eerror
313 + eerror "USE=\"mingw\" is currently experimental, and requires the"
314 + eerror "'cross-x86_64-w64-mingw32' compiler and its runtime for 64-bit builds."
315 + eerror
316 + eerror "These can be installed by using 'sys-devel/crossdev':"
317 + eerror
318 + eerror "crossdev --target x86_64-w64-mingw32"
319 + eerror
320 + eerror "For more information on setting up MinGW, see: https://wiki.gentoo.org/wiki/Mingw"
321 + eerror
322 + die "MinGW build was enabled, but no compiler to support it was found."
323 + fi
324 +}
325 +
326 +pkg_setup() {
327 + wine_build_environment_check || die
328 + wine_env_vcs_vars || die
329 +
330 + WINE_VARIANT="${PN#wine}-${PV}"
331 + WINE_VARIANT="${WINE_VARIANT#-}"
332 +
333 + MY_PREFIX="${EPREFIX}/usr/lib/wine-${WINE_VARIANT}"
334 + MY_DATAROOTDIR="${EPREFIX}/usr/share/wine-${WINE_VARIANT}"
335 + MY_DATADIR="${MY_DATAROOTDIR}"
336 + MY_DOCDIR="${EPREFIX}/usr/share/doc/${PF}"
337 + MY_INCLUDEDIR="${EPREFIX}/usr/include/wine-${WINE_VARIANT}"
338 + MY_LIBEXECDIR="${EPREFIX}/usr/libexec/wine-${WINE_VARIANT}"
339 + MY_LOCALSTATEDIR="${EPREFIX}/var/wine-${WINE_VARIANT}"
340 + MY_MANDIR="${MY_DATADIR}/man"
341 +}
342 +
343 +src_unpack() {
344 + if [[ ${PV} == "9999" ]] ; then
345 + EGIT_CHECKOUT_DIR="${S}" git-r3_src_unpack
346 + fi
347 +
348 + default
349 +
350 + l10n_find_plocales_changes "${S}/po" "" ".po"
351 +}
352 +
353 +src_prepare() {
354 +
355 + eapply_bin(){
356 + local patch
357 + for patch in ${PATCHES_BIN[@]}; do
358 + patchbin --nogit < "${patch}" || die
359 + done
360 + }
361 +
362 + local md5="$(md5sum server/protocol.def)"
363 +
364 + default
365 + eapply_bin
366 + eautoreconf
367 +
368 + # Modification of the server protocol requires regenerating the server requests
369 + if [[ "$(md5sum server/protocol.def)" != "${md5}" ]]; then
370 + einfo "server/protocol.def was patched; running tools/make_requests"
371 + tools/make_requests || die #432348
372 + fi
373 + sed -i '/^UPDATE_DESKTOP_DATABASE/s:=.*:=true:' tools/Makefile.in || die
374 + if ! use run-exes; then
375 + sed -i '/^MimeType/d' loader/wine.desktop || die #117785
376 + fi
377 +
378 + # Edit wine.desktop to work for specific variant
379 + sed -e "/^Exec=/s/wine /wine-${WINE_VARIANT} /" -i loader/wine.desktop || die
380 +
381 + # hi-res default icon, #472990, https://bugs.winehq.org/show_bug.cgi?id=24652
382 + cp "${PATCHDIR}/files/oic_winlogo.ico" dlls/user32/resources/ || die
383 +
384 + l10n_get_locales > po/LINGUAS || die # otherwise wine doesn't respect LINGUAS
385 +
386 + # Fix manpage generation for locales #469418 and abi_x86_64 #617864
387 +
388 + # Duplicate manpages input files for wine64
389 + local f
390 + for f in loader/*.man.in; do
391 + cp ${f} ${f/wine/wine64} || die
392 + done
393 + # Add wine64 manpages to Makefile
394 + if use abi_x86_64; then
395 + sed -i "/wine.man.in/i \
396 + \\\twine64.man.in \\\\" loader/Makefile.in || die
397 + sed -i -E 's/(.*wine)(.*\.UTF-8\.man\.in.*)/&\
398 +\164\2/' loader/Makefile.in || die
399 + fi
400 +
401 + rm_man_file(){
402 + local file="${1}"
403 + loc=${2}
404 + sed -i "/${loc}\.UTF-8\.man\.in/d" "${file}" || die
405 + }
406 +
407 + while read f; do
408 + l10n_for_each_disabled_locale_do rm_man_file "${f}"
409 + done < <(find -name "Makefile.in" -exec grep -q "UTF-8.man.in" "{}" \; -print)
410 +}
411 +
412 +src_configure() {
413 + wine_compiler_check || die
414 +
415 + export LDCONFIG=/bin/true
416 + use custom-cflags || strip-flags
417 + if use mingw; then
418 + export CROSSCFLAGS="${CFLAGS}"
419 + fi
420 +
421 + multilib-minimal_src_configure
422 +}
423 +
424 +multilib_src_configure() {
425 + local myconf=(
426 + --prefix="${MY_PREFIX}"
427 + --datarootdir="${MY_DATAROOTDIR}"
428 + --datadir="${MY_DATADIR}"
429 + --docdir="${MY_DOCDIR}"
430 + --includedir="${MY_INCLUDEDIR}"
431 + --libdir="${EPREFIX}/usr/$(get_libdir)/wine-${WINE_VARIANT}"
432 + --libexecdir="${MY_LIBEXECDIR}"
433 + --localstatedir="${MY_LOCALSTATEDIR}"
434 + --mandir="${MY_MANDIR}"
435 + --sysconfdir="${EPREFIX}/etc/wine"
436 + $(use_with alsa)
437 + $(use_with capi)
438 + $(use_with lcms cms)
439 + $(use_with cups)
440 + $(use_with udisks dbus)
441 + $(use_with faudio)
442 + $(use_with fontconfig)
443 + $(use_with ssl gnutls)
444 + $(use_enable gecko mshtml)
445 + $(use_with gphoto2 gphoto)
446 + $(use_with gsm)
447 + $(use_with gssapi)
448 + $(use_with gstreamer)
449 + --without-hal
450 + $(use_with jpeg)
451 + $(use_with kerberos krb5)
452 + $(use_with ldap)
453 + # TODO: Will bug 685172 still need special handling?
454 + $(use_with mingw)
455 + $(use_enable mono mscoree)
456 + $(use_with mp3 mpg123)
457 + $(use_with netapi)
458 + $(use_with nls gettext)
459 + $(use_with openal)
460 + $(use_with opencl)
461 + $(use_with opengl)
462 + $(use_with osmesa)
463 + $(use_with oss)
464 + $(use_with pcap)
465 + $(use_with png)
466 + $(use_with pulseaudio pulse)
467 + $(use_with threads pthread)
468 + $(use_with scanner sane)
469 + $(use_with sdl)
470 + $(use_enable test tests)
471 + $(use_with truetype freetype)
472 + $(use_with udev)
473 + $(use_with unwind)
474 + $(use_with usb)
475 + $(use_with v4l v4l2)
476 + $(use_with vkd3d)
477 + $(use_with vulkan)
478 + $(use_with X x)
479 + $(use_with X xfixes)
480 + $(use_with xcomposite)
481 + $(use_with xinerama)
482 + $(use_with xml)
483 + $(use_with xml xslt)
484 + )
485 +
486 + local PKG_CONFIG
487 + # Avoid crossdev's i686-pc-linux-gnu-pkg-config if building wine32 on amd64; #472038
488 + tc-export PKG_CONFIG
489 +
490 + if use amd64; then
491 + if [[ ${ABI} == amd64 ]]; then
492 + myconf+=( --enable-win64 )
493 + else
494 + myconf+=( --disable-win64 )
495 + fi
496 +
497 + # Note: using --with-wine64 results in problems with multilib.eclass
498 + # CC/LD hackery. We're using separate tools instead.
499 + fi
500 +
501 + ECONF_SOURCE=${S} \
502 + econf "${myconf[@]}"
503 + emake depend
504 +}
505 +
506 +multilib_src_test() {
507 + # FIXME: win32-only; wine64 tests fail with "could not find the Wine loader"
508 + if [[ ${ABI} == x86 ]]; then
509 + if [[ $(id -u) == 0 ]]; then
510 + ewarn "Skipping tests since they cannot be run under the root user."
511 + ewarn "To run the test ${MY_PN} suite, add userpriv to FEATURES in make.conf"
512 + return
513 + fi
514 +
515 + WINEPREFIX="${T}/.wine-${ABI}" \
516 + Xemake test
517 + fi
518 +}
519 +
520 +multilib_src_install_all() {
521 + local DOCS=( ANNOUNCE AUTHORS README )
522 + add_locale_docs() {
523 + local locale_doc="documentation/README.$1"
524 + [[ ! -e ${locale_doc} ]] || DOCS+=( ${locale_doc} )
525 + }
526 + l10n_for_each_locale_do add_locale_docs
527 +
528 + einstalldocs
529 + prune_libtool_files --all
530 +
531 + if ! use perl ; then # winedump calls function_grep.pl, and winemaker is a perl script
532 + rm "${D%/}${MY_PREFIX}"/bin/{wine{dump,maker},function_grep.pl} \
533 + "${D%/}${MY_MANDIR}"/man1/wine{dump,maker}.1 || die
534 + fi
535 +
536 + # Remove wineconsole if neither backend is installed #551124
537 + if ! use X; then
538 + rm "${D%/}${MY_PREFIX}"/bin/wineconsole* || die
539 + rm "${D%/}${MY_MANDIR}"/man1/wineconsole* || die
540 +
541 + if ! use mingw; then
542 + rm_wineconsole() {
543 + rm "${D%/}/usr/$(get_libdir)/wine-${WINE_VARIANT}"/wine/{,fakedlls/}wineconsole.exe* || die
544 + }
545 + else
546 + rm_wineconsole() {
547 + rm "${D%/}/usr/$(get_libdir)/wine-${WINE_VARIANT}"/wine/wineconsole.exe* || die
548 + }
549 + fi
550 +
551 + multilib_foreach_abi rm_wineconsole
552 + fi
553 +
554 + use abi_x86_32 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine{,-preloader} #255055
555 + use abi_x86_64 && pax-mark psmr "${D%/}${MY_PREFIX}"/bin/wine64{,-preloader}
556 +
557 + # Avoid double prefix from dosym and make_wrapper
558 + MY_PREFIX=${MY_PREFIX#${EPREFIX}}
559 +
560 + if use abi_x86_64 && ! use abi_x86_32; then
561 + dosym wine64 "${MY_PREFIX}"/bin/wine # 404331
562 + dosym wine64-preloader "${MY_PREFIX}"/bin/wine-preloader
563 + fi
564 +
565 + # Failglob for binloops, shouldn't be necessary, but including to stay safe
566 + eshopts_push -s failglob #615218
567 + # Make wrappers for binaries for handling multiple variants
568 + # Note: wrappers instead of symlinks because some are shell which use basename
569 + local b
570 + for b in "${ED%/}${MY_PREFIX}"/bin/*; do
571 + make_wrapper "${b##*/}-${WINE_VARIANT}" "${MY_PREFIX}/bin/${b##*/}"
572 + done
573 + eshopts_pop
574 +}
575 +
576 +pkg_postinst() {
577 + eselect wine register ${P}
578 + if [[ ${PN} == "wine-vanilla" ]]; then
579 + eselect wine register --vanilla ${P} || die
580 + fi
581 +
582 + eselect wine update --all --if-unset || die
583 +
584 + xdg_desktop_database_update
585 +
586 + if ! use gecko; then
587 + ewarn "Without Wine Gecko, wine prefixes will not have a default"
588 + ewarn "implementation of iexplore. Many older windows applications"
589 + ewarn "rely upon the existence of an iexplore implementation, so"
590 + ewarn "you will likely need to install an external one, like via winetricks"
591 + fi
592 + if ! use mono; then
593 + ewarn "Without Wine Mono, wine prefixes will not have a default"
594 + ewarn "implementation of .NET. Many windows applications rely upon"
595 + ewarn "the existence of a .NET implementation, so you will likely need"
596 + ewarn "to install an external one, like via winetricks"
597 + fi
598 +}
599 +
600 +pkg_prerm() {
601 + eselect wine deregister ${P}
602 + if [[ ${PN} == "wine-vanilla" ]]; then
603 + eselect wine deregister --vanilla ${P} || die
604 + fi
605 +
606 + eselect wine update --all --if-unset || die
607 +}
608 +
609 +pkg_postrm() {
610 + xdg_desktop_database_update
611 +}